#ifndef _ENGINE
#define _ENGINE

#include "level.h"

#define DIALOG_INTRO 0
#define DIALOG_END 6
#define NB_CONFETTI 30

#define SPEED_FALLING 2
#define SPEED_BULLET 4


typedef enum {QUIT, RETRY, NEXT} Return_code;

typedef struct {
	char x, y, dy, position;
} Confetti;

/* public functions */
int engine_main(int id_level);
void engine_intro(int page);

/* private functions */
static Return_code engine_loop(Level* level);
static void engine_movements(Level* level);
static void engine_move_objects(Level* level);
static void engine_anim(Level* level);
static int engine_collisions(Level* level);
static int engine_hitMap(Level* level, Object* object, int dx, int dy);

#endif
