#ifndef _LEVEL
#define _LEVEL

#include "object.h"

#define NB_LEVEL 40

typedef enum {
	OUT=-1, EMPTY, GROUND, BEGIN, // -1 ~ 2
	EGG_UP, EGG_DOWN, EGG_LEFT, EGG_RIGHT, // 3 ~ 6
	SPIKE_UP, SPIKE_DOWN, SPIKE_LEFT, SPIKE_RIGHT, // 7 ~ 10
	GRAVITY_PLUS, GRAVITY_MINUS, // 11 ~ 12
	HORIZONTAL_CUBE, VERTICAL_CUBE, // 13 ~ 14
	HORIZONTAL_CATERPILLAR, VERTICAL_CATERPILLAR, // 15 ~ 16
	PLANT_LEFT_1, PLANT_RIGHT_1, // 17 ~ 18
	PLANT_LEFT_2, PLANT_RIGHT_2, // 19 ~ 20
	BEE_1, BEE_2, // 21 ~ 22
	PESTLE_UP_1, PESTLE_DOWN_1, PESTLE_LEFT_1, PESTLE_RIGHT_1, // 23 ~ 26
	PESTLE_UP_2, PESTLE_DOWN_2, PESTLE_LEFT_2, PESTLE_RIGHT_2 // 27 ~ 30
} Map_item;

typedef struct {
	short width, height;
	char* map;
	Direction gravity;
	Object** object;
} Level;

/* public functions */
Level* level_load(int n);
void level_free(Level* level);

/* private functions */
static Level* level_create(char* map, int width, int height);

#endif
