#ifndef _TILESET
#define _TILESET

typedef enum {
	TITLE, SELECT_LEVEL, BUTTON, PAUSE, STATUE, CHEST, CONGRATULATIONS, HAT_DUCK,
	T_GROUND,
	GROUND_MASK_UP, GROUND_MASK_RIGHT, GROUND_MASK_DOWN, GROUND_MASK_LEFT,
	T_SPIKE_UP, T_SPIKE_RIGHT, T_SPIKE_DOWN, T_SPIKE_LEFT,
	T_EGG_UP, T_EGG_DOWN, T_EGG_RIGHT, T_EGG_LEFT, EGG_CAUGHT,
	DUCK_UP_RIGHT, DUCK_UP_LEFT, DUCK_DOWN_RIGHT, DUCK_DOWN_LEFT, DUCK_RIGHT_UP, DUCK_RIGHT_DOWN, DUCK_LEFT_UP, DUCK_LEFT_DOWN,
	T_GRAVITY_SWITCH,
	T_CUBE,
	CATERPILLAR_UP_RIGHT, CATERPILLAR_UP_LEFT, CATERPILLAR_DOWN_RIGHT, CATERPILLAR_DOWN_LEFT, CATERPILLAR_RIGHT_UP, CATERPILLAR_RIGHT_DOWN, CATERPILLAR_LEFT_UP, CATERPILLAR_LEFT_DOWN,
	T_PLANT_RIGHT, T_PLANT_LEFT,
	T_BEE_RIGHT, T_BEE_LEFT, BEE_HALO,
	T_BULLET,
	T_PESTLE_UP, T_PESTLE_DOWN, T_PESTLE_RIGHT, T_PESTLE_LEFT
} Tileset_name;

typedef struct {
	int width, height, length;
	char** tile;
} Tileset;

/* public functions */
Tileset* tileset_load (Tileset_name name);
void tileset_free(Tileset* tileset);

/* private functions */
static Tileset* tileset_create (const char* bmp, int width, int height, int length);
static void tileset_horizontal_symmetry(Tileset* tileset);
static void tileset_vertical_symmetry(Tileset* tileset);
static void tileset_rotation_90_degrees(Tileset* tileset);
#endif

